# BaseFilterReader

Extends \FilterReader

Base class for core filter readers.

author | Yannick Lecaillez
version | $Id: 85cbd982d211b5d05761bd3043d2583b890bdc64 $
see |
package | phing.filters

### Methods

## __construct

    __construct(\Reader $in = null)

inherited

### Arguments

#### $in

`\Reader`

## Close stream.

    close()

inherited abstract

throws | if there is an error closing stream

## Returns whether the end of file has been reached with input stream.

    eof() : boolean

### Response

`boolean`

## Returns the initialized status.

    getInitialized() : boolean

### Response

`boolean`

whether or not the filter is initialized

## Returns the project this filter is part of.

    getProject() : object

### Response

`object`

The project this filter is part of

## Returns the filename, url, etc. that is being read from.

    getResource() : string

inherited abstract

This is critical for, e.g., ExpatParser's ability to know the filename that is throwing an ExpatParserException, etc.

### Response

`string`

## Convenience method to support logging in filters.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

### Arguments

#### $msg

`string`

Message to log.

#### $level

`integer`

Priority level.

## If supported, places a "marker" (like a bookmark) at current stream position.

    mark()

inherited

A subsequent call to reset() will move stream position back to last marker (if supported).

## Whether marking is supported.

    markSupported() : boolean

inherited

### Response

`boolean`

## Read data from source.

    read(integer $len = null)

inherited abstract

If length is specified, then only that number of chars is read, otherwise stream is read until EOF.

### Arguments

#### $len

`integer`

## Reads a line of text ending with '\n' (or until the end of the stream).

    readLine() : string

The returned String retains the '\n'.

throws | if the underlying reader throws one during reading

### Response

`string`

the line read, or `null` if the end of the stream has already been reached

## Is stream ready for reading.

    ready() : boolean

inherited

### Response

`boolean`

## Reset the current position in stream to beginning or last mark (if supported).

    reset()

inherited

## Sets the initialized status.

    setInitialized(boolean $initialized)

### Arguments

#### $initialized

`boolean`

Whether or not the filter is initialized.

## Sets the project to work with.

    setProject(object|\Project $project)

### Arguments

#### $project

`object|\Project`

The project this filter is part of. Should not be `null`.

## setReader

    setReader(\Reader $in)

inherited

### Arguments

#### $in

`\Reader`

## Move stream position relative to current pos.

    skip(integer $n)

inherited

### Arguments

#### $n

`integer`

### Properties

## Have the parameters passed been interpreted?

    initialized :

### Type(s)

``

## The Phing project this filter is part of.

    project :

### Type(s)

``

## in

    in : \Reader

inherited

var |

### Type(s)

`\Reader`